﻿<!doctype html>
<html lang="es">
<head>
	<title>Cargas ETL</title>
	<script type="text/javascript" src="http://code.jquery.com/jquery-2.1.1.min.js"></script>

	<!-- Compiled and minified CSS -->
  <link rel="stylesheet" href="http://cdnjs.cloudflare.com/ajax/libs/materialize/0.96.1/css/materialize.min.css">

  <!-- Compiled and minified JavaScript -->
  <script src="http://cdnjs.cloudflare.com/ajax/libs/materialize/0.96.1/js/materialize.min.js"></script>

	<script src="http://d3js.org/d3.v3.min.js" charset="utf-8"></script>

	<script src="moment.js" charset="utf-8"></script>
	<script src="moment-recur.min.js"></script>
	<script src="view_logic.js" charset="utf-8"></script>
	<script src="business_logic.js" charset="utf-8"></script>

	<link href='http://fonts.googleapis.com/css?family=Play:400,700'
		rel='stylesheet' type='text/css'>

	<style>
	body{
		font-family: 'Play', sans-serif;
	}

	#timeline_widget{
		width: 100%;
		overflow-x: scroll;
	}

	</style>
</head>
<body>
	<div id="formulario" class="row">
		<div class="left col s12 m4 l3">
			<label for="datepicker">Fecha inicio</label>
			<input id="f_inicio_html" type="date" class="datepicker">
		</div>
		<div class="left input-field col s12 m4 l3">
	    <select id="tipo">
	      <option value="1">Optimizaciones mejoradas</option>
	      <option value="2" selected>Carga en varios días</option>
	      <option value="3">Stagin</option>
	    </select>
			<label>Tipo de carga</label>
	  </div>
		<div class="left switch col s12 m4 l3">
	    <label>
	      Inicio manual
	      <input id="check" type="checkbox">
	      <span class="lever"></span>
	      Inicio automático
	    </label>
	  </div>
	</div>
	<div id="timeline_widget"></div>
	<div class="row">
		<h3>Leyenda</h3>
		<table class="valign col s8 m8 l4">
			<tr>
				<td>Cliente</td>
				<td>Carga 1</td>
				<td>Carga 2</td>
			</tr>
			<tr>
				<td>Cliente A</td>
				<td style="background-color: rgb(146,175,243)"></td>
				<td style="background-color: rgb(60,103,203)"></td>
			</tr>
			<tr>
				<td>Cliente B</td>
				<td style="background-color: rgb(255,51,0)"></td>
				<td style="background-color: rgb(191,51,0)"></td>
			</tr>
			<tr>
				<td>Cliente C</td>
				<td style="background-color: rgb(255,255,153)"></td>
				<td style="background-color: rgb(242,242,40)"></td>
			</tr>
			<tr>
				<td>Entidad validadora</td>
				<td style="background-color: rgb(221,235,247)"></td>
			</tr>
			<tr>
				<td>Migración datos</td>
				<td style="background-color: rgb(90,90,90)"></td>
			</tr>
		</table>
	</div>
	<div>
		<h3>Explicación visualización</h3>
		<p>
			En esta visualización se ilustran las cargas ETL de datos de un cliente que
			tiene unos procesos de carga muy largos. Para ello usamos una línea roja
			del tiempo de la que cuelgan cajas que representan las cargas de datos. Si
			la caja se encuentra sobre la línea la carga de datos corresponde a
			Pre-producción. Si la caja se encuentra sobre la línea corresponde a
			Producción. El ancho de la caja represnta el tiempo necesario para la carga.
		</p>
		<p>
			La visualicación presenta tres opciones para reducir los tiempos de carga.
			Optimizaciones mejoradas, Carga en varios días y Staging. Cada una de ellas
			permite tener los datos cargados con diferente rango de días. El cliente
			debe elegir una.
		</p>
	</div>
	<script>
		// ---------- datos --------------
		var ancho = 9000, alto = 200;
		var todos_los_trabajos = new Array();
		var dias = [];
		var meses = [];

		var f_ini=new Date(), f_fin=moment(f_ini).add(3,'M').startOf('M').toDate();

		// ---------- Escala -------------
		var timeline = d3.select("#timeline_widget")
			.append("svg:svg")
			.attr("height", alto)
			.attr("width", ancho);
		var fondo = timeline.append("g");
		var linea = timeline.append("g");

		// ---------- logica -------------
		function refresh(){
			// inicio seleccionado
			f_ini = moment( $('#f_inicio_html').pickadate('picker').get('value'), "DD/MM/YYYY" ).toDate() || new Date();
			f_ini.setHours(0);
			// siempre tres meses despues
			f_fin = f_fin=moment(f_ini).add(3,'M').startOf('M').toDate();

			todos_los_trabajos.length=0;
			todos_los_trabajos = todos_los_trabajos.concat( generarCargaDia(f_ini, f_fin, 6, $("#tipo").val(), $("#check")[0].checked) );
			todos_los_trabajos = todos_los_trabajos.concat( generarCargaDia(f_ini, f_fin, 28, $("#tipo").val(), $("#check")[0].checked) );

			meses = generarMeses(f_ini, f_fin);
			dias = generarDias(f_ini, f_fin);

			render_timeline();
		}

		// --------------------- UI -----------------------
		$(document).ready(function(){
			var f_inicio_ui = $('#f_inicio_html').pickadate({
				selectMonths: true, // Creates a dropdown to control month
					format: "dd/mm/yyyy",
				selectYears: 2 // Creates a dropdown of 15 years to control year
			});
			f_inicio_ui.pickadate('picker').on({
				close: refresh
			});
			f_inicio_ui.pickadate('picker').set('select',f_ini.getTime());
			var tipo = $("#tipo");
			tipo.material_select();
			tipo.change(refresh);
			$("#check").change(refresh)

			refresh();
		});


	</script>
</body>
</html>
